#ifndef __INCLUDE_JM_GUI_BI__
#define __INCLUDE_JM_GUI_BI__

#ifndef YAGL
#ifdef YAGL_BI_
#define YAGL
#endif
#endif

#ifdef YAGL

#inclib "jmgui_yagl"

#ifdef __FB_LINUX__
#include "yaglwrapperlinux.bi"
#else
#include "yaglwrapper.bi"
#endif
#include "jm_gui_key_yagl.bi"

#else
#ifdef MYGL

#inclib "jmgui_mygl"
#include "mygl.bi"
#include "jm_gui_key_mygl.bi"

#else

#inclib "jmgui_fbgfx"
#include "jm_gui_key_fbgfx.bi"

#endif
#endif

#include "jm_gui_base.bi"
#include "jm_image.bi"
#include "jm_font.bi"
#include "jm_con.bi"
#include "jm_boxes.bi"
#include "jm_boxes_color.bi"

#include "jm_boxes_std.bi"
#include "jm_boxes_std_edit.bi"
#include "jm_boxes_std_input.bi"
#include "jm_boxes_std_scroll.bi"

#endif
