#ifndef __INCLUDE_JM_HACK_BI
#define __INCLUDE_JM_HACK_BI

#if 1

'' Use fb ctors and dtors

#define EMIT_GLOBAL_CTOR(name_):''
#define EMIT_GLOBAL_DTOR(name_):''

#define FB_CONSTRUCTOR Constructor
#define FB_DESTRUCTOR Destructor

'#define BEGIN_CTOR(name_) Private Sub name_ cdecl alias name_ () Constructor
#define END_CTOR End Sub
'#define BEGIN_DTOR(name_) Private Sub name_ cdecl alias name_ () Destructor
#define END_DTOR End Sub

#else

'' Use global ctors/dtors

#ifdef __FB_LINUX__

#define BEGIN_CTOR(name_) Sub name_ cdecl alias name_ ()
#define EMIT_GLOBAL_CTOR(name_) asm : _
  .section .ctors,""""w"""" ; _
  .align 4 ; _
  .long name_ ; _
  .section .text ; _
 end asm
#define END_CTOR End Sub

#define BEGIN_DTOR(name_) Sub name_ cdecl alias name_ ()
#define EMIT_GLOBAL_DTOR(name_) asm : _
  .section .dtors,""""w"""" ; _
  .align 4 ; _
  .long name_ ; _
  .section .text ; _
 end asm
#define END_DTOR End Sub

#else

#define BEGIN_CTOR(name_) Sub name_ cdecl alias name_ ()
#define EMIT_GLOBAL_CTOR(name_) asm : _
  .section .ctors,""""w"""" ; _
  .align 4 ; _
  .long name_ ; _
  .section .text ; _
 end asm
#define END_CTOR End Sub

#define BEGIN_DTOR(name_) Sub name_ cdecl alias name_ ()
#define EMIT_GLOBAL_DTOR(name_) asm : _
  .section .dtors,""""w"""" ; _
  .align 4 ; _
  .long name_ ; _
  .section .text ; _
 end asm
#define END_DTOR End Sub

#endif

#endif
