#ifndef __INCLUDE_JM_FONT_FNTFILE_BI__
#define __INCLUDE_JM_FONT_FNTFILE_BI__

Type JM_FONT_FNT_FILE_T field = 1

	sig as integer        '' "FNT\0"
	size as integer       '' sizeof(JM_FONT_FNT_FILE_T) - 8
	fonttype as integer   '' 0 = fixed bitmap, 1 = var-bitmap
	char1 as short        '' 0
	charn as short        '' 256
  maxw as short         '' max glyph bitmap width
  maxh as short         '' max glyph bitmap height
	cax as short          '' standard glyph advance width
	cay as short          '' standard glyph advance height
	cbx as short          '' standard glyph bearing left
	cby as short          '' standard glyph bearing top
	reserved as integer   '' reserved must be 0
End Type

Type JM_FONT_FNT_CHAR_T field = 1
  
	sig as integer        '' "CHR\0"
	size as integer       '' sizeof(JM_FONT_FNT_CHAR_T) - 8
	c0 as ubyte           '' ascii character
	c1 as ubyte           '' '\0'
	c2 as ubyte           '' '\0'
	c3 as ubyte           '' '\0'
	cgx as short          '' glyph width
	cgy as short          '' glyph height
	cax as short          '' glyph advance width
	cay as short          '' glyph advance height
	cbx as short          '' glyph bearing left
	cby as short          '' glyph bearing top
  doffset as integer    '' offset from start of file to glyph data
	reserved as integer   '' reserved must be 0
End Type

Type JM_FONT_FNT_GLYPH_T field = 1

	sig as integer        '' "GLY\0"
	size as integer       '' 0
  '' char pixeldata[]   '' 
End Type

#endif
